=begin
#BillForward REST API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3-SNAPSHOT

=end

require "uri"

module Bfwd
  class CouponbookApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # Create a coupon-book.
    # {\"nickname\":\"Create a new coupon book\",\"request\":\"createCouponBookRequest.html\",\"response\":\"createCouponBookResponse.html\"}
    # @param coupon_book The coupon-book object to be created.
    # @param [Hash] opts the optional parameters
    # @return [CouponBookPagedMetadata]
    def create_coupon_book(coupon_book, opts = {})
      data, _status_code, _headers = create_coupon_book_with_http_info(coupon_book, opts)
      return data
    end

    # Create a coupon-book.
    # {\&quot;nickname\&quot;:\&quot;Create a new coupon book\&quot;,\&quot;request\&quot;:\&quot;createCouponBookRequest.html\&quot;,\&quot;response\&quot;:\&quot;createCouponBookResponse.html\&quot;}
    # @param coupon_book The coupon-book object to be created.
    # @param [Hash] opts the optional parameters
    # @return [Array<(CouponBookPagedMetadata, Fixnum, Hash)>] CouponBookPagedMetadata data, response status code and response headers
    def create_coupon_book_with_http_info(coupon_book, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CouponbookApi.create_coupon_book ..."
      end
      # verify the required parameter 'coupon_book' is set
      if @api_client.config.client_side_validation && coupon_book.nil?
        fail ArgumentError, "Missing the required parameter 'coupon_book' when calling CouponbookApi.create_coupon_book"
      end
      # resource path
      local_var_path = "/coupon-books"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['text/xml', 'application/xml', 'application/json; charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json; charset=utf-8'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(coupon_book)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CouponBookPagedMetadata')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CouponbookApi#create_coupon_book\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Retire a coupon-book, specified by the coupon-book-ID parameter.
    # {\"nickname\":\"Delete coupon book\",\"response\":\"deleteCouponBookByID.html\"}
    # @param coupon_book_id ID of the coupon-book.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :organizations A list of organization-IDs used to restrict the scope of API calls.
    # @return [CouponBookPagedMetadata]
    def delete_coupon_book(coupon_book_id, opts = {})
      data, _status_code, _headers = delete_coupon_book_with_http_info(coupon_book_id, opts)
      return data
    end

    # Retire a coupon-book, specified by the coupon-book-ID parameter.
    # {\&quot;nickname\&quot;:\&quot;Delete coupon book\&quot;,\&quot;response\&quot;:\&quot;deleteCouponBookByID.html\&quot;}
    # @param coupon_book_id ID of the coupon-book.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :organizations A list of organization-IDs used to restrict the scope of API calls.
    # @return [Array<(CouponBookPagedMetadata, Fixnum, Hash)>] CouponBookPagedMetadata data, response status code and response headers
    def delete_coupon_book_with_http_info(coupon_book_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CouponbookApi.delete_coupon_book ..."
      end
      # verify the required parameter 'coupon_book_id' is set
      if @api_client.config.client_side_validation && coupon_book_id.nil?
        fail ArgumentError, "Missing the required parameter 'coupon_book_id' when calling CouponbookApi.delete_coupon_book"
      end
      # resource path
      local_var_path = "/coupon-books/{coupon-book-ID}".sub('{' + 'coupon-book-ID' + '}', coupon_book_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'organizations'] = @api_client.build_collection_param(opts[:'organizations'], :multi) if !opts[:'organizations'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json; charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['text/plain'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CouponBookPagedMetadata')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CouponbookApi#delete_coupon_book\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns a collection of attachable coupon-books. An attachable coupon-book has at least one remaining use, and is not deleted. By default 10 values are returned. Records are returned in natural order.
    # {\"nickname\":\"Get all attachable coupon books\",\"response\":\"getCouponBookAllAttachable.html\"}
    # @param attachableness The attachableness of the coupon-book.
    # @param has_code Whether the coupon-books have book codes or not.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :organizations A list of organization-IDs used to restrict the scope of API calls.
    # @option opts [Integer] :offset The offset from the first coupon-book to return. (default to 0)
    # @option opts [Integer] :records The maximum number of coupon-books to return. (default to 10)
    # @option opts [String] :order_by Specify a field used to order the result set. (default to created)
    # @option opts [String] :order Ihe direction of any ordering, either ASC or DESC. (default to DESC)
    # @return [CouponBookPagedMetadata]
    def get_all_attachable_coupon_books(attachableness, has_code, opts = {})
      data, _status_code, _headers = get_all_attachable_coupon_books_with_http_info(attachableness, has_code, opts)
      return data
    end

    # Returns a collection of attachable coupon-books. An attachable coupon-book has at least one remaining use, and is not deleted. By default 10 values are returned. Records are returned in natural order.
    # {\&quot;nickname\&quot;:\&quot;Get all attachable coupon books\&quot;,\&quot;response\&quot;:\&quot;getCouponBookAllAttachable.html\&quot;}
    # @param attachableness The attachableness of the coupon-book.
    # @param has_code Whether the coupon-books have book codes or not.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :organizations A list of organization-IDs used to restrict the scope of API calls.
    # @option opts [Integer] :offset The offset from the first coupon-book to return.
    # @option opts [Integer] :records The maximum number of coupon-books to return.
    # @option opts [String] :order_by Specify a field used to order the result set.
    # @option opts [String] :order Ihe direction of any ordering, either ASC or DESC.
    # @return [Array<(CouponBookPagedMetadata, Fixnum, Hash)>] CouponBookPagedMetadata data, response status code and response headers
    def get_all_attachable_coupon_books_with_http_info(attachableness, has_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CouponbookApi.get_all_attachable_coupon_books ..."
      end
      # verify the required parameter 'attachableness' is set
      if @api_client.config.client_side_validation && attachableness.nil?
        fail ArgumentError, "Missing the required parameter 'attachableness' when calling CouponbookApi.get_all_attachable_coupon_books"
      end
      # verify the required parameter 'has_code' is set
      if @api_client.config.client_side_validation && has_code.nil?
        fail ArgumentError, "Missing the required parameter 'has_code' when calling CouponbookApi.get_all_attachable_coupon_books"
      end
      if @api_client.config.client_side_validation && opts[:'order'] && !['ASC', 'DESC'].include?(opts[:'order'])
        fail ArgumentError, 'invalid value for "order", must be one of ASC, DESC'
      end
      # resource path
      local_var_path = "/coupon-books/attachable/{attachableness}/{has_code}".sub('{' + 'attachableness' + '}', attachableness.to_s).sub('{' + 'has_code' + '}', has_code.to_s)

      # query parameters
      query_params = {}
      query_params[:'organizations'] = @api_client.build_collection_param(opts[:'organizations'], :multi) if !opts[:'organizations'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'records'] = opts[:'records'] if !opts[:'records'].nil?
      query_params[:'order_by'] = opts[:'order_by'] if !opts[:'order_by'].nil?
      query_params[:'order'] = opts[:'order'] if !opts[:'order'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json; charset=utf-8'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CouponBookPagedMetadata')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CouponbookApi#get_all_attachable_coupon_books\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns a collection of coupon-books. By default 10 values are returned. Records are returned in natural order.
    # {\"nickname\":\"Get all coupon books\",\"response\":\"getCouponBookAll.html\"}
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :organizations A list of organization-IDs used to restrict the scope of API calls.
    # @option opts [Integer] :offset The offset from the first coupon-books to return. (default to 0)
    # @option opts [Integer] :records The maximum number of coupon-books to return. (default to 10)
    # @option opts [String] :order_by Specify a field used to order the result set. (default to created)
    # @option opts [String] :order Ihe direction of any ordering, either ASC or DESC. (default to DESC)
    # @option opts [BOOLEAN] :include_retired Whether retired coupon-books should be returned. (default to true)
    # @return [CouponBookPagedMetadata]
    def get_all_coupon_books(opts = {})
      data, _status_code, _headers = get_all_coupon_books_with_http_info(opts)
      return data
    end

    # Returns a collection of coupon-books. By default 10 values are returned. Records are returned in natural order.
    # {\&quot;nickname\&quot;:\&quot;Get all coupon books\&quot;,\&quot;response\&quot;:\&quot;getCouponBookAll.html\&quot;}
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :organizations A list of organization-IDs used to restrict the scope of API calls.
    # @option opts [Integer] :offset The offset from the first coupon-books to return.
    # @option opts [Integer] :records The maximum number of coupon-books to return.
    # @option opts [String] :order_by Specify a field used to order the result set.
    # @option opts [String] :order Ihe direction of any ordering, either ASC or DESC.
    # @option opts [BOOLEAN] :include_retired Whether retired coupon-books should be returned.
    # @return [Array<(CouponBookPagedMetadata, Fixnum, Hash)>] CouponBookPagedMetadata data, response status code and response headers
    def get_all_coupon_books_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CouponbookApi.get_all_coupon_books ..."
      end
      if @api_client.config.client_side_validation && opts[:'order'] && !['ASC', 'DESC'].include?(opts[:'order'])
        fail ArgumentError, 'invalid value for "order", must be one of ASC, DESC'
      end
      # resource path
      local_var_path = "/coupon-books"

      # query parameters
      query_params = {}
      query_params[:'organizations'] = @api_client.build_collection_param(opts[:'organizations'], :multi) if !opts[:'organizations'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'records'] = opts[:'records'] if !opts[:'records'].nil?
      query_params[:'order_by'] = opts[:'order_by'] if !opts[:'order_by'].nil?
      query_params[:'order'] = opts[:'order'] if !opts[:'order'].nil?
      query_params[:'include_retired'] = opts[:'include_retired'] if !opts[:'include_retired'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json; charset=utf-8'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CouponBookPagedMetadata')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CouponbookApi#get_all_coupon_books\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns a single coupon-book, specified by the book-code parameter.
    # {\"nickname\":\"Retrieve by book code\",\"response\":\"getCouponBookByBookCode.html\"}
    # @param book_code The unique coupon-book-code.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :organizations A list of organization-IDs used to restrict the scope of API calls.
    # @return [CouponBookPagedMetadata]
    def get_coupon_book_by_book_code(book_code, opts = {})
      data, _status_code, _headers = get_coupon_book_by_book_code_with_http_info(book_code, opts)
      return data
    end

    # Returns a single coupon-book, specified by the book-code parameter.
    # {\&quot;nickname\&quot;:\&quot;Retrieve by book code\&quot;,\&quot;response\&quot;:\&quot;getCouponBookByBookCode.html\&quot;}
    # @param book_code The unique coupon-book-code.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :organizations A list of organization-IDs used to restrict the scope of API calls.
    # @return [Array<(CouponBookPagedMetadata, Fixnum, Hash)>] CouponBookPagedMetadata data, response status code and response headers
    def get_coupon_book_by_book_code_with_http_info(book_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CouponbookApi.get_coupon_book_by_book_code ..."
      end
      # verify the required parameter 'book_code' is set
      if @api_client.config.client_side_validation && book_code.nil?
        fail ArgumentError, "Missing the required parameter 'book_code' when calling CouponbookApi.get_coupon_book_by_book_code"
      end
      # resource path
      local_var_path = "/coupon-books/book-code/{book-code}".sub('{' + 'book-code' + '}', book_code.to_s)

      # query parameters
      query_params = {}
      query_params[:'organizations'] = @api_client.build_collection_param(opts[:'organizations'], :multi) if !opts[:'organizations'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json; charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['text/plain'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CouponBookPagedMetadata')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CouponbookApi#get_coupon_book_by_book_code\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns a collection of coupon-books, specified by coupon-book-definition-ID parameter. By default 10 coupon-books are returned. Records are returned in natural order.
    # {\"nickname\":\"Retrieve by coupon book definition\",\"response\":\"getCouponBookByCouponBookDefinitionID.html\"}
    # @param coupon_book_definition_id The string coupon-book-definition-ID of the coupon-book.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :organizations A list of organization-IDs used to restrict the scope of API calls.
    # @option opts [Integer] :offset The offset from the first coupon-book to return. (default to 0)
    # @option opts [Integer] :records The maximum number of coupon-books to return. (default to 10)
    # @option opts [String] :order_by Specify a field used to order the result set. (default to created)
    # @option opts [String] :order Ihe direction of any ordering, either ASC or DESC. (default to DESC)
    # @option opts [BOOLEAN] :include_retired Whether retired coupon-books should be returned. (default to true)
    # @return [CouponBookPagedMetadata]
    def get_coupon_book_by_coupon_book_definition_id(coupon_book_definition_id, opts = {})
      data, _status_code, _headers = get_coupon_book_by_coupon_book_definition_id_with_http_info(coupon_book_definition_id, opts)
      return data
    end

    # Returns a collection of coupon-books, specified by coupon-book-definition-ID parameter. By default 10 coupon-books are returned. Records are returned in natural order.
    # {\&quot;nickname\&quot;:\&quot;Retrieve by coupon book definition\&quot;,\&quot;response\&quot;:\&quot;getCouponBookByCouponBookDefinitionID.html\&quot;}
    # @param coupon_book_definition_id The string coupon-book-definition-ID of the coupon-book.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :organizations A list of organization-IDs used to restrict the scope of API calls.
    # @option opts [Integer] :offset The offset from the first coupon-book to return.
    # @option opts [Integer] :records The maximum number of coupon-books to return.
    # @option opts [String] :order_by Specify a field used to order the result set.
    # @option opts [String] :order Ihe direction of any ordering, either ASC or DESC.
    # @option opts [BOOLEAN] :include_retired Whether retired coupon-books should be returned.
    # @return [Array<(CouponBookPagedMetadata, Fixnum, Hash)>] CouponBookPagedMetadata data, response status code and response headers
    def get_coupon_book_by_coupon_book_definition_id_with_http_info(coupon_book_definition_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CouponbookApi.get_coupon_book_by_coupon_book_definition_id ..."
      end
      # verify the required parameter 'coupon_book_definition_id' is set
      if @api_client.config.client_side_validation && coupon_book_definition_id.nil?
        fail ArgumentError, "Missing the required parameter 'coupon_book_definition_id' when calling CouponbookApi.get_coupon_book_by_coupon_book_definition_id"
      end
      if @api_client.config.client_side_validation && opts[:'order'] && !['ASC', 'DESC'].include?(opts[:'order'])
        fail ArgumentError, 'invalid value for "order", must be one of ASC, DESC'
      end
      # resource path
      local_var_path = "/coupon-books/coupon-book-definition/{coupon-book-definition-ID}".sub('{' + 'coupon-book-definition-ID' + '}', coupon_book_definition_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'organizations'] = @api_client.build_collection_param(opts[:'organizations'], :multi) if !opts[:'organizations'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'records'] = opts[:'records'] if !opts[:'records'].nil?
      query_params[:'order_by'] = opts[:'order_by'] if !opts[:'order_by'].nil?
      query_params[:'order'] = opts[:'order'] if !opts[:'order'].nil?
      query_params[:'include_retired'] = opts[:'include_retired'] if !opts[:'include_retired'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json; charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['text/plain'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CouponBookPagedMetadata')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CouponbookApi#get_coupon_book_by_coupon_book_definition_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns a single coupon-book, specified by the coupon-code parameter.
    # {\"nickname\":\"Retrieve by coupon code\",\"response\":\"getCouponBookByBookCode.html\"}
    # @param coupon_code The unique coupon-code.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :organizations A list of organization-IDs used to restrict the scope of API calls.
    # @return [CouponBookPagedMetadata]
    def get_coupon_book_by_coupon_code(coupon_code, opts = {})
      data, _status_code, _headers = get_coupon_book_by_coupon_code_with_http_info(coupon_code, opts)
      return data
    end

    # Returns a single coupon-book, specified by the coupon-code parameter.
    # {\&quot;nickname\&quot;:\&quot;Retrieve by coupon code\&quot;,\&quot;response\&quot;:\&quot;getCouponBookByBookCode.html\&quot;}
    # @param coupon_code The unique coupon-code.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :organizations A list of organization-IDs used to restrict the scope of API calls.
    # @return [Array<(CouponBookPagedMetadata, Fixnum, Hash)>] CouponBookPagedMetadata data, response status code and response headers
    def get_coupon_book_by_coupon_code_with_http_info(coupon_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CouponbookApi.get_coupon_book_by_coupon_code ..."
      end
      # verify the required parameter 'coupon_code' is set
      if @api_client.config.client_side_validation && coupon_code.nil?
        fail ArgumentError, "Missing the required parameter 'coupon_code' when calling CouponbookApi.get_coupon_book_by_coupon_code"
      end
      # resource path
      local_var_path = "/coupon-books/coupon/{coupon-code}".sub('{' + 'coupon-code' + '}', coupon_code.to_s)

      # query parameters
      query_params = {}
      query_params[:'organizations'] = @api_client.build_collection_param(opts[:'organizations'], :multi) if !opts[:'organizations'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json; charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['text/plain'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CouponBookPagedMetadata')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CouponbookApi#get_coupon_book_by_coupon_code\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns a single coupon-book, specified by the coupon-book-ID parameter.
    # {\"nickname\":\"Retrieve an existing coupon book\",\"response\":\"getCouponBookByID.html\"}
    # @param coupon_book_id ID of the coupon-book.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :organizations A list of organization-IDs used to restrict the scope of API calls.
    # @return [CouponBookPagedMetadata]
    def get_coupon_book_by_id(coupon_book_id, opts = {})
      data, _status_code, _headers = get_coupon_book_by_id_with_http_info(coupon_book_id, opts)
      return data
    end

    # Returns a single coupon-book, specified by the coupon-book-ID parameter.
    # {\&quot;nickname\&quot;:\&quot;Retrieve an existing coupon book\&quot;,\&quot;response\&quot;:\&quot;getCouponBookByID.html\&quot;}
    # @param coupon_book_id ID of the coupon-book.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :organizations A list of organization-IDs used to restrict the scope of API calls.
    # @return [Array<(CouponBookPagedMetadata, Fixnum, Hash)>] CouponBookPagedMetadata data, response status code and response headers
    def get_coupon_book_by_id_with_http_info(coupon_book_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CouponbookApi.get_coupon_book_by_id ..."
      end
      # verify the required parameter 'coupon_book_id' is set
      if @api_client.config.client_side_validation && coupon_book_id.nil?
        fail ArgumentError, "Missing the required parameter 'coupon_book_id' when calling CouponbookApi.get_coupon_book_by_id"
      end
      # resource path
      local_var_path = "/coupon-books/{coupon-book-ID}".sub('{' + 'coupon-book-ID' + '}', coupon_book_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'organizations'] = @api_client.build_collection_param(opts[:'organizations'], :multi) if !opts[:'organizations'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json; charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['text/plain'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CouponBookPagedMetadata')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CouponbookApi#get_coupon_book_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a coupon-book.
    # {\"nickname\":\"Update a coupon book\",\"request\":\"updateCouponBookRequest.html\",\"response\":\"updateCouponBookResponse.html\"}
    # @param coupon_book The coupon-book object to be updated.
    # @param [Hash] opts the optional parameters
    # @return [CouponBookPagedMetadata]
    def update_coupon_book(coupon_book, opts = {})
      data, _status_code, _headers = update_coupon_book_with_http_info(coupon_book, opts)
      return data
    end

    # Update a coupon-book.
    # {\&quot;nickname\&quot;:\&quot;Update a coupon book\&quot;,\&quot;request\&quot;:\&quot;updateCouponBookRequest.html\&quot;,\&quot;response\&quot;:\&quot;updateCouponBookResponse.html\&quot;}
    # @param coupon_book The coupon-book object to be updated.
    # @param [Hash] opts the optional parameters
    # @return [Array<(CouponBookPagedMetadata, Fixnum, Hash)>] CouponBookPagedMetadata data, response status code and response headers
    def update_coupon_book_with_http_info(coupon_book, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: CouponbookApi.update_coupon_book ..."
      end
      # verify the required parameter 'coupon_book' is set
      if @api_client.config.client_side_validation && coupon_book.nil?
        fail ArgumentError, "Missing the required parameter 'coupon_book' when calling CouponbookApi.update_coupon_book"
      end
      # resource path
      local_var_path = "/coupon-books"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['text/xml', 'application/xml', 'application/json; charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json; charset=utf-8'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(coupon_book)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CouponBookPagedMetadata')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CouponbookApi#update_coupon_book\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
