=begin
#BillForward REST API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3-SNAPSHOT

=end

require "uri"

module Bfwd
  class PaymentmethodsubscriptionlinksApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # Create
    # {\"nickname\":\"Add a payment method to a subscription\",\"request\":\"createPaymentMethodSubscriptionLinkRequest.html\",\"response\":\"createPaymentMethodSubscriptionLinkResponse.html\"}
    # @param payment_method The payment-method object to be updated.
    # @param [Hash] opts the optional parameters
    # @return [PaymentMethodSubscriptionLinkPagedMetadata]
    def create_payment_method_subscription_link(payment_method, opts = {})
      data, _status_code, _headers = create_payment_method_subscription_link_with_http_info(payment_method, opts)
      return data
    end

    # Create
    # {\&quot;nickname\&quot;:\&quot;Add a payment method to a subscription\&quot;,\&quot;request\&quot;:\&quot;createPaymentMethodSubscriptionLinkRequest.html\&quot;,\&quot;response\&quot;:\&quot;createPaymentMethodSubscriptionLinkResponse.html\&quot;}
    # @param payment_method The payment-method object to be updated.
    # @param [Hash] opts the optional parameters
    # @return [Array<(PaymentMethodSubscriptionLinkPagedMetadata, Fixnum, Hash)>] PaymentMethodSubscriptionLinkPagedMetadata data, response status code and response headers
    def create_payment_method_subscription_link_with_http_info(payment_method, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PaymentmethodsubscriptionlinksApi.create_payment_method_subscription_link ..."
      end
      # verify the required parameter 'payment_method' is set
      if @api_client.config.client_side_validation && payment_method.nil?
        fail ArgumentError, "Missing the required parameter 'payment_method' when calling PaymentmethodsubscriptionlinksApi.create_payment_method_subscription_link"
      end
      # resource path
      local_var_path = "/payment-method-subscription-links"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['text/xml', 'application/xml', 'application/json; charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json; charset=utf-8'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(payment_method)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PaymentMethodSubscriptionLinkPagedMetadata')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PaymentmethodsubscriptionlinksApi#create_payment_method_subscription_link\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Retires the payment-method-subscription-link specified by the link-ID parameter.
    # {\"nickname\":\"Remove a payment method from a subscription\",\"response\":\"deletePaymentMethodSubscriptionLink.html\"}
    # @param payment_method_subscription_link_id ID of the link.
    # @param organizations A list of organization-IDs used to restrict the scope of API calls.
    # @param [Hash] opts the optional parameters
    # @return [PaymentMethodSubscriptionLinkPagedMetadata]
    def retire_payment_method_subscription_link(payment_method_subscription_link_id, organizations, opts = {})
      data, _status_code, _headers = retire_payment_method_subscription_link_with_http_info(payment_method_subscription_link_id, organizations, opts)
      return data
    end

    # Retires the payment-method-subscription-link specified by the link-ID parameter.
    # {\&quot;nickname\&quot;:\&quot;Remove a payment method from a subscription\&quot;,\&quot;response\&quot;:\&quot;deletePaymentMethodSubscriptionLink.html\&quot;}
    # @param payment_method_subscription_link_id ID of the link.
    # @param organizations A list of organization-IDs used to restrict the scope of API calls.
    # @param [Hash] opts the optional parameters
    # @return [Array<(PaymentMethodSubscriptionLinkPagedMetadata, Fixnum, Hash)>] PaymentMethodSubscriptionLinkPagedMetadata data, response status code and response headers
    def retire_payment_method_subscription_link_with_http_info(payment_method_subscription_link_id, organizations, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PaymentmethodsubscriptionlinksApi.retire_payment_method_subscription_link ..."
      end
      # verify the required parameter 'payment_method_subscription_link_id' is set
      if @api_client.config.client_side_validation && payment_method_subscription_link_id.nil?
        fail ArgumentError, "Missing the required parameter 'payment_method_subscription_link_id' when calling PaymentmethodsubscriptionlinksApi.retire_payment_method_subscription_link"
      end
      # verify the required parameter 'organizations' is set
      if @api_client.config.client_side_validation && organizations.nil?
        fail ArgumentError, "Missing the required parameter 'organizations' when calling PaymentmethodsubscriptionlinksApi.retire_payment_method_subscription_link"
      end
      # resource path
      local_var_path = "/payment-method-subscription-links/{payment-method-subscription-link-ID}".sub('{' + 'payment-method-subscription-link-ID' + '}', payment_method_subscription_link_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'organizations'] = @api_client.build_collection_param(organizations, :multi)

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json; charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['text/plain'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PaymentMethodSubscriptionLinkPagedMetadata')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PaymentmethodsubscriptionlinksApi#retire_payment_method_subscription_link\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
