=begin
#BillForward REST API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3-SNAPSHOT

=end

require "uri"

module Bfwd
  class PricingcalculatorApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # Calculates the price of a subscription's upgrading/downgrading to a new pricing component value.
    # { \"nickname\" : \"Calculate upgrade price\", \"request\" : \"AmendmentPriceRequest.html\" ,\"response\" : \"AmendmentPriceNTime.html\" }
    # @param ammendment_price_request An amendment pricing request
    # @param [Hash] opts the optional parameters
    # @return [AmendmentPriceNTimePagedMetadata]
    def get_amendment_cost(ammendment_price_request, opts = {})
      data, _status_code, _headers = get_amendment_cost_with_http_info(ammendment_price_request, opts)
      return data
    end

    # Calculates the price of a subscription&#39;s upgrading/downgrading to a new pricing component value.
    # { \&quot;nickname\&quot; : \&quot;Calculate upgrade price\&quot;, \&quot;request\&quot; : \&quot;AmendmentPriceRequest.html\&quot; ,\&quot;response\&quot; : \&quot;AmendmentPriceNTime.html\&quot; }
    # @param ammendment_price_request An amendment pricing request
    # @param [Hash] opts the optional parameters
    # @return [Array<(AmendmentPriceNTimePagedMetadata, Fixnum, Hash)>] AmendmentPriceNTimePagedMetadata data, response status code and response headers
    def get_amendment_cost_with_http_info(ammendment_price_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PricingcalculatorApi.get_amendment_cost ..."
      end
      # verify the required parameter 'ammendment_price_request' is set
      if @api_client.config.client_side_validation && ammendment_price_request.nil?
        fail ArgumentError, "Missing the required parameter 'ammendment_price_request' when calling PricingcalculatorApi.get_amendment_cost"
      end
      # resource path
      local_var_path = "/pricing-calculator/amendment-cost"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json; charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json; charset=utf-8'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(ammendment_price_request)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AmendmentPriceNTimePagedMetadata')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PricingcalculatorApi#get_amendment_cost\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Calculates the price of a subscription to a rate plan, at specified values of pricing component values, and with the specified coupon applied.
    # { \"nickname\" : \"Calculate price with a coupon\",\"request\" : \"PriceRequestWithCoupon.html\" ,\"response\" : \"PriceCalculationWithCoupon.html\" }
    # @param coupon_instance_initialisation_request A coupon instance initialisation request
    # @param [Hash] opts the optional parameters
    # @return [PriceCalculationPagedMetadata]
    def get_coupon_instance_initialisation_cost(coupon_instance_initialisation_request, opts = {})
      data, _status_code, _headers = get_coupon_instance_initialisation_cost_with_http_info(coupon_instance_initialisation_request, opts)
      return data
    end

    # Calculates the price of a subscription to a rate plan, at specified values of pricing component values, and with the specified coupon applied.
    # { \&quot;nickname\&quot; : \&quot;Calculate price with a coupon\&quot;,\&quot;request\&quot; : \&quot;PriceRequestWithCoupon.html\&quot; ,\&quot;response\&quot; : \&quot;PriceCalculationWithCoupon.html\&quot; }
    # @param coupon_instance_initialisation_request A coupon instance initialisation request
    # @param [Hash] opts the optional parameters
    # @return [Array<(PriceCalculationPagedMetadata, Fixnum, Hash)>] PriceCalculationPagedMetadata data, response status code and response headers
    def get_coupon_instance_initialisation_cost_with_http_info(coupon_instance_initialisation_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PricingcalculatorApi.get_coupon_instance_initialisation_cost ..."
      end
      # verify the required parameter 'coupon_instance_initialisation_request' is set
      if @api_client.config.client_side_validation && coupon_instance_initialisation_request.nil?
        fail ArgumentError, "Missing the required parameter 'coupon_instance_initialisation_request' when calling PricingcalculatorApi.get_coupon_instance_initialisation_cost"
      end
      # resource path
      local_var_path = "/pricing-calculator/coupon-instance/initialisation"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json; charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json; charset=utf-8'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(coupon_instance_initialisation_request)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PriceCalculationPagedMetadata')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PricingcalculatorApi#get_coupon_instance_initialisation_cost\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Calculates the price of a subscription to a rate plan, at specified values of pricing component values.
    # { \"nickname\" : \"Calculate price\", \"request\" : \"PriceRequest.html\" ,\"response\" : \"PriceCalculation.html\" }
    # @param price_request A price request
    # @param [Hash] opts the optional parameters
    # @return [PriceCalculationPagedMetadata]
    def get_product_rate_plan_costs(price_request, opts = {})
      data, _status_code, _headers = get_product_rate_plan_costs_with_http_info(price_request, opts)
      return data
    end

    # Calculates the price of a subscription to a rate plan, at specified values of pricing component values.
    # { \&quot;nickname\&quot; : \&quot;Calculate price\&quot;, \&quot;request\&quot; : \&quot;PriceRequest.html\&quot; ,\&quot;response\&quot; : \&quot;PriceCalculation.html\&quot; }
    # @param price_request A price request
    # @param [Hash] opts the optional parameters
    # @return [Array<(PriceCalculationPagedMetadata, Fixnum, Hash)>] PriceCalculationPagedMetadata data, response status code and response headers
    def get_product_rate_plan_costs_with_http_info(price_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PricingcalculatorApi.get_product_rate_plan_costs ..."
      end
      # verify the required parameter 'price_request' is set
      if @api_client.config.client_side_validation && price_request.nil?
        fail ArgumentError, "Missing the required parameter 'price_request' when calling PricingcalculatorApi.get_product_rate_plan_costs"
      end
      # resource path
      local_var_path = "/pricing-calculator/product-rate-plan"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json; charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json; charset=utf-8'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(price_request)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PriceCalculationPagedMetadata')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PricingcalculatorApi#get_product_rate_plan_costs\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
