=begin
#BillForward REST API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3-SNAPSHOT

=end

require 'date'

module Bfwd
  # An oAuth2 client with which BillForward users may authenticate.
  class Client
    # { \"description\" : \"The UTC DateTime when the object was created.\", \"verbs\":[] }
    attr_accessor :created

    # { \"description\" : \"ID of the user who last updated the entity.\", \"verbs\":[] }
    attr_accessor :changed_by

    # { \"description\" : \"The UTC DateTime when the object was last updated.\", \"verbs\":[] }
    attr_accessor :updated

    # { \"description\" : \"ID of the OAuth2 client.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :client_id

    # { \"description\" : \"Unique Client Secret of the client. This is used as the OAuth2 Client secret\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :client_secret

    # { \"description\" : \"Organization associated with the client.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :organization_id

    # { \"description\" : \"Scopes associated with the client.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :scope

    # { \"description\" : \"Resources associated with the client.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :resource_ids

    # { \"description\" : \"Oauth2 Grant Types which may be used when authenticating with the client.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :authorized_grant_types

    # { \"description\" : \"Registered Redirect URIs associated with the client.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :registered_redirect_uris

    # { \"description\" : \"Authorities associated with the client.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :authorities

    # { \"description\" : \"The amount of time in seconds that an access token for the client is valid.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :access_token_validity_seconds

    # { \"description\" : \"The amount of time in seconds that a refresh token for the client is valid.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :refresh_token_validity_seconds

    # { \"description\" : \"Indicates if a client has been retired. If a client has been retired it can still be retrieved using the appropriate flag on API requests.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :deleted


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'created' => :'created',
        :'changed_by' => :'changedBy',
        :'updated' => :'updated',
        :'client_id' => :'clientId',
        :'client_secret' => :'clientSecret',
        :'organization_id' => :'organizationID',
        :'scope' => :'scope',
        :'resource_ids' => :'resourceIds',
        :'authorized_grant_types' => :'authorizedGrantTypes',
        :'registered_redirect_uris' => :'registeredRedirectUris',
        :'authorities' => :'authorities',
        :'access_token_validity_seconds' => :'accessTokenValiditySeconds',
        :'refresh_token_validity_seconds' => :'refreshTokenValiditySeconds',
        :'deleted' => :'deleted'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'created' => :'DateTime',
        :'changed_by' => :'String',
        :'updated' => :'DateTime',
        :'client_id' => :'String',
        :'client_secret' => :'String',
        :'organization_id' => :'String',
        :'scope' => :'String',
        :'resource_ids' => :'String',
        :'authorized_grant_types' => :'String',
        :'registered_redirect_uris' => :'String',
        :'authorities' => :'String',
        :'access_token_validity_seconds' => :'Integer',
        :'refresh_token_validity_seconds' => :'Integer',
        :'deleted' => :'BOOLEAN'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'created')
        self.created = attributes[:'created']
      end

      if attributes.has_key?(:'changedBy')
        self.changed_by = attributes[:'changedBy']
      end

      if attributes.has_key?(:'updated')
        self.updated = attributes[:'updated']
      end

      if attributes.has_key?(:'clientId')
        self.client_id = attributes[:'clientId']
      end

      if attributes.has_key?(:'clientSecret')
        self.client_secret = attributes[:'clientSecret']
      end

      if attributes.has_key?(:'organizationID')
        self.organization_id = attributes[:'organizationID']
      end

      if attributes.has_key?(:'scope')
        self.scope = attributes[:'scope']
      end

      if attributes.has_key?(:'resourceIds')
        self.resource_ids = attributes[:'resourceIds']
      end

      if attributes.has_key?(:'authorizedGrantTypes')
        self.authorized_grant_types = attributes[:'authorizedGrantTypes']
      end

      if attributes.has_key?(:'registeredRedirectUris')
        self.registered_redirect_uris = attributes[:'registeredRedirectUris']
      end

      if attributes.has_key?(:'authorities')
        self.authorities = attributes[:'authorities']
      end

      if attributes.has_key?(:'accessTokenValiditySeconds')
        self.access_token_validity_seconds = attributes[:'accessTokenValiditySeconds']
      end

      if attributes.has_key?(:'refreshTokenValiditySeconds')
        self.refresh_token_validity_seconds = attributes[:'refreshTokenValiditySeconds']
      end

      if attributes.has_key?(:'deleted')
        self.deleted = attributes[:'deleted']
      else
        self.deleted = false
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @client_secret.nil?
        invalid_properties.push("invalid value for 'client_secret', client_secret cannot be nil.")
      end

      if @organization_id.nil?
        invalid_properties.push("invalid value for 'organization_id', organization_id cannot be nil.")
      end

      if @scope.nil?
        invalid_properties.push("invalid value for 'scope', scope cannot be nil.")
      end

      if @resource_ids.nil?
        invalid_properties.push("invalid value for 'resource_ids', resource_ids cannot be nil.")
      end

      if @authorized_grant_types.nil?
        invalid_properties.push("invalid value for 'authorized_grant_types', authorized_grant_types cannot be nil.")
      end

      if @registered_redirect_uris.nil?
        invalid_properties.push("invalid value for 'registered_redirect_uris', registered_redirect_uris cannot be nil.")
      end

      if @authorities.nil?
        invalid_properties.push("invalid value for 'authorities', authorities cannot be nil.")
      end

      if @access_token_validity_seconds.nil?
        invalid_properties.push("invalid value for 'access_token_validity_seconds', access_token_validity_seconds cannot be nil.")
      end

      if @refresh_token_validity_seconds.nil?
        invalid_properties.push("invalid value for 'refresh_token_validity_seconds', refresh_token_validity_seconds cannot be nil.")
      end

      if @deleted.nil?
        invalid_properties.push("invalid value for 'deleted', deleted cannot be nil.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @client_secret.nil?
      return false if @organization_id.nil?
      return false if @scope.nil?
      return false if @resource_ids.nil?
      return false if @authorized_grant_types.nil?
      return false if @registered_redirect_uris.nil?
      return false if @authorities.nil?
      return false if @access_token_validity_seconds.nil?
      return false if @refresh_token_validity_seconds.nil?
      return false if @deleted.nil?
      return true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          created == o.created &&
          changed_by == o.changed_by &&
          updated == o.updated &&
          client_id == o.client_id &&
          client_secret == o.client_secret &&
          organization_id == o.organization_id &&
          scope == o.scope &&
          resource_ids == o.resource_ids &&
          authorized_grant_types == o.authorized_grant_types &&
          registered_redirect_uris == o.registered_redirect_uris &&
          authorities == o.authorities &&
          access_token_validity_seconds == o.access_token_validity_seconds &&
          refresh_token_validity_seconds == o.refresh_token_validity_seconds &&
          deleted == o.deleted
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [created, changed_by, updated, client_id, client_secret, organization_id, scope, resource_ids, authorized_grant_types, registered_redirect_uris, authorities, access_token_validity_seconds, refresh_token_validity_seconds, deleted].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Bfwd.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
