=begin
#BillForward REST API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3-SNAPSHOT

=end

require 'date'

module Bfwd
  # A coupon-instance.
  class CouponInstance
    # { \"description\" : \"Target ID of the coupon-instance. If the target is subscription, this is the subscription's ID. If the target is account, this is the account's ID.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :target_id

    # { \"description\" : \"Code for the coupon. This code can be used to apply coupon-instances to subscriptions or accounts.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :coupon_code

    # { \"description\" : \"The UTC DateTime the coupon was initialised.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :date_initialised

    # { \"description\" : \"The UTC DateTime the coupon-instance is valid until.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :valid_till

    # { \"description\" : \"The UTC DateTime when the object was created.\", \"verbs\":[] }
    attr_accessor :created

    # { \"description\" : \"ID of the user who last updated the entity.\", \"verbs\":[] }
    attr_accessor :changed_by

    # { \"description\" : \"The UTC DateTime when the object was last updated.\", \"verbs\":[] }
    attr_accessor :updated

    # { \"description\" : \"ID of the coupon-instance.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :id

    # { \"description\" : \"CRM ID of the product-rate-plan.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :crm_id

    # { \"description\" : \"Organization associated with the\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :organization_id

    # { \"description\" : \"ID of the coupon-book associated with the coupon-instance.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :book_id

    # { \"description\" : \"ID of the coupon-definition associated with the coupon-instance.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :coupon_definition_id

    # { \"description\" : \"Ttype of the target for the coupon-instance. Used in combination with the targetID.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :target

    # { \"description\" : \"Number of subscription periods the coupon is valid for. Unused.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :periods_valid_for

    # { \"description\" : \"Unused.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :total_periods

    # { \"description\" : \"The number of remaining uses the coupon-instance has left.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :remaining_uses

    # { \"description\" : \"(Optional) The value to be used for dynamic price calculation, if the coupon definition has an 'instance' or 'instance_percent' coupon modifier. If it is not set, the effect amount of the coupon modifier will be used.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :instance_discount_value

    # { \"description\" : \"The number of remaining uses the coupon-instance had upon initialisation.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :max_remaining_uses

    # { \"description\" : \"The collection of coupon-instance-existing-value objects associated with the coupon-instance.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :coupon_instance_existing_values

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'target_id' => :'targetID',
        :'coupon_code' => :'couponCode',
        :'date_initialised' => :'dateInitialised',
        :'valid_till' => :'validTill',
        :'created' => :'created',
        :'changed_by' => :'changedBy',
        :'updated' => :'updated',
        :'id' => :'id',
        :'crm_id' => :'crmID',
        :'organization_id' => :'organizationID',
        :'book_id' => :'bookID',
        :'coupon_definition_id' => :'couponDefinitionID',
        :'target' => :'target',
        :'periods_valid_for' => :'periodsValidFor',
        :'total_periods' => :'totalPeriods',
        :'remaining_uses' => :'remainingUses',
        :'instance_discount_value' => :'instanceDiscountValue',
        :'max_remaining_uses' => :'maxRemainingUses',
        :'coupon_instance_existing_values' => :'couponInstanceExistingValues'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'target_id' => :'String',
        :'coupon_code' => :'String',
        :'date_initialised' => :'DateTime',
        :'valid_till' => :'DateTime',
        :'created' => :'DateTime',
        :'changed_by' => :'String',
        :'updated' => :'DateTime',
        :'id' => :'String',
        :'crm_id' => :'String',
        :'organization_id' => :'String',
        :'book_id' => :'String',
        :'coupon_definition_id' => :'String',
        :'target' => :'String',
        :'periods_valid_for' => :'Integer',
        :'total_periods' => :'Integer',
        :'remaining_uses' => :'Integer',
        :'instance_discount_value' => :'Float',
        :'max_remaining_uses' => :'Integer',
        :'coupon_instance_existing_values' => :'Array<CouponInstanceExistingValue>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'targetID')
        self.target_id = attributes[:'targetID']
      end

      if attributes.has_key?(:'couponCode')
        self.coupon_code = attributes[:'couponCode']
      end

      if attributes.has_key?(:'dateInitialised')
        self.date_initialised = attributes[:'dateInitialised']
      end

      if attributes.has_key?(:'validTill')
        self.valid_till = attributes[:'validTill']
      end

      if attributes.has_key?(:'created')
        self.created = attributes[:'created']
      end

      if attributes.has_key?(:'changedBy')
        self.changed_by = attributes[:'changedBy']
      end

      if attributes.has_key?(:'updated')
        self.updated = attributes[:'updated']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'crmID')
        self.crm_id = attributes[:'crmID']
      end

      if attributes.has_key?(:'organizationID')
        self.organization_id = attributes[:'organizationID']
      end

      if attributes.has_key?(:'bookID')
        self.book_id = attributes[:'bookID']
      end

      if attributes.has_key?(:'couponDefinitionID')
        self.coupon_definition_id = attributes[:'couponDefinitionID']
      end

      if attributes.has_key?(:'target')
        self.target = attributes[:'target']
      end

      if attributes.has_key?(:'periodsValidFor')
        self.periods_valid_for = attributes[:'periodsValidFor']
      end

      if attributes.has_key?(:'totalPeriods')
        self.total_periods = attributes[:'totalPeriods']
      end

      if attributes.has_key?(:'remainingUses')
        self.remaining_uses = attributes[:'remainingUses']
      end

      if attributes.has_key?(:'instanceDiscountValue')
        self.instance_discount_value = attributes[:'instanceDiscountValue']
      end

      if attributes.has_key?(:'maxRemainingUses')
        self.max_remaining_uses = attributes[:'maxRemainingUses']
      end

      if attributes.has_key?(:'couponInstanceExistingValues')
        if (value = attributes[:'couponInstanceExistingValues']).is_a?(Array)
          self.coupon_instance_existing_values = value
        end
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @date_initialised.nil?
        invalid_properties.push("invalid value for 'date_initialised', date_initialised cannot be nil.")
      end

      if @crm_id.nil?
        invalid_properties.push("invalid value for 'crm_id', crm_id cannot be nil.")
      end

      if @organization_id.nil?
        invalid_properties.push("invalid value for 'organization_id', organization_id cannot be nil.")
      end

      if @book_id.nil?
        invalid_properties.push("invalid value for 'book_id', book_id cannot be nil.")
      end

      if @coupon_definition_id.nil?
        invalid_properties.push("invalid value for 'coupon_definition_id', coupon_definition_id cannot be nil.")
      end

      if @target.nil?
        invalid_properties.push("invalid value for 'target', target cannot be nil.")
      end

      if @periods_valid_for.nil?
        invalid_properties.push("invalid value for 'periods_valid_for', periods_valid_for cannot be nil.")
      end

      if @total_periods.nil?
        invalid_properties.push("invalid value for 'total_periods', total_periods cannot be nil.")
      end

      if @remaining_uses.nil?
        invalid_properties.push("invalid value for 'remaining_uses', remaining_uses cannot be nil.")
      end

      if @max_remaining_uses.nil?
        invalid_properties.push("invalid value for 'max_remaining_uses', max_remaining_uses cannot be nil.")
      end

      if @coupon_instance_existing_values.nil?
        invalid_properties.push("invalid value for 'coupon_instance_existing_values', coupon_instance_existing_values cannot be nil.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @date_initialised.nil?
      return false if @crm_id.nil?
      return false if @organization_id.nil?
      return false if @book_id.nil?
      return false if @coupon_definition_id.nil?
      return false if @target.nil?
      target_validator = EnumAttributeValidator.new('String', ["none", "subscription", "account"])
      return false unless target_validator.valid?(@target)
      return false if @periods_valid_for.nil?
      return false if @total_periods.nil?
      return false if @remaining_uses.nil?
      return false if @max_remaining_uses.nil?
      return false if @coupon_instance_existing_values.nil?
      return true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] target Object to be assigned
    def target=(target)
      validator = EnumAttributeValidator.new('String', ["none", "subscription", "account"])
      unless validator.valid?(target)
        fail ArgumentError, "invalid value for 'target', must be one of #{validator.allowable_values}."
      end
      @target = target
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          target_id == o.target_id &&
          coupon_code == o.coupon_code &&
          date_initialised == o.date_initialised &&
          valid_till == o.valid_till &&
          created == o.created &&
          changed_by == o.changed_by &&
          updated == o.updated &&
          id == o.id &&
          crm_id == o.crm_id &&
          organization_id == o.organization_id &&
          book_id == o.book_id &&
          coupon_definition_id == o.coupon_definition_id &&
          target == o.target &&
          periods_valid_for == o.periods_valid_for &&
          total_periods == o.total_periods &&
          remaining_uses == o.remaining_uses &&
          instance_discount_value == o.instance_discount_value &&
          max_remaining_uses == o.max_remaining_uses &&
          coupon_instance_existing_values == o.coupon_instance_existing_values
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [target_id, coupon_code, date_initialised, valid_till, created, changed_by, updated, id, crm_id, organization_id, book_id, coupon_definition_id, target, periods_valid_for, total_periods, remaining_uses, instance_discount_value, max_remaining_uses, coupon_instance_existing_values].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Bfwd.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
