=begin
#BillForward REST API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3-SNAPSHOT

=end

require 'date'

module Bfwd
  # Insertable entities are those entities that can be created.
  class InsertableBillingEntity
    # { \"description\" : \"The UTC DateTime when the pricing-component-value-change was processed.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :applied

    # { \"description\" : \"The UTC DateTime when the object was created.\", \"verbs\":[] }
    attr_accessor :created

    # { \"description\" : \"ID of the user who last updated the entity.\", \"verbs\":[] }
    attr_accessor :changed_by

    # { \"description\" : \"ID of the pricing-component-value-change.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :id

    # { \"description\" : \"ID of the pricing-component associated with the pricing-component-value-change.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :pricing_component_id

    # { \"description\" : \"ID of the unit-of-measure associated with the pricing-component-value-change.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :unit_of_measure_id

    # { \"description\" : \"ID of the subscription associated with the pricing-component-value-change.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :subscription_id

    # { \"description\" : \"ID of the invoice associated with the pricing-component-value-change.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :invoice_id

    # { \"description\" : \"The organizationID.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :organization_id

    # { \"description\" : \"The new value of the pricing-component.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :new_value

    # { \"description\" : \"The new value of the pricing-component.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :old_value

    # { \"description\" : \"The value change mode.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :mode

    # { \"description\" : \"The value change state.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :state

    # { \"description\" : \"The UTC DateTime when the pricing-component-value-change was calculated.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :as_of

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'applied' => :'applied',
        :'created' => :'created',
        :'changed_by' => :'changedBy',
        :'id' => :'id',
        :'pricing_component_id' => :'pricingComponentID',
        :'unit_of_measure_id' => :'unitOfMeasureID',
        :'subscription_id' => :'subscriptionID',
        :'invoice_id' => :'invoiceID',
        :'organization_id' => :'organizationID',
        :'new_value' => :'newValue',
        :'old_value' => :'oldValue',
        :'mode' => :'mode',
        :'state' => :'state',
        :'as_of' => :'asOf'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'applied' => :'DateTime',
        :'created' => :'DateTime',
        :'changed_by' => :'String',
        :'id' => :'String',
        :'pricing_component_id' => :'String',
        :'unit_of_measure_id' => :'String',
        :'subscription_id' => :'String',
        :'invoice_id' => :'String',
        :'organization_id' => :'String',
        :'new_value' => :'Integer',
        :'old_value' => :'Integer',
        :'mode' => :'String',
        :'state' => :'String',
        :'as_of' => :'DateTime'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'applied')
        self.applied = attributes[:'applied']
      end

      if attributes.has_key?(:'created')
        self.created = attributes[:'created']
      end

      if attributes.has_key?(:'changedBy')
        self.changed_by = attributes[:'changedBy']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'pricingComponentID')
        self.pricing_component_id = attributes[:'pricingComponentID']
      end

      if attributes.has_key?(:'unitOfMeasureID')
        self.unit_of_measure_id = attributes[:'unitOfMeasureID']
      end

      if attributes.has_key?(:'subscriptionID')
        self.subscription_id = attributes[:'subscriptionID']
      end

      if attributes.has_key?(:'invoiceID')
        self.invoice_id = attributes[:'invoiceID']
      end

      if attributes.has_key?(:'organizationID')
        self.organization_id = attributes[:'organizationID']
      end

      if attributes.has_key?(:'newValue')
        self.new_value = attributes[:'newValue']
      end

      if attributes.has_key?(:'oldValue')
        self.old_value = attributes[:'oldValue']
      end

      if attributes.has_key?(:'mode')
        self.mode = attributes[:'mode']
      end

      if attributes.has_key?(:'state')
        self.state = attributes[:'state']
      end

      if attributes.has_key?(:'asOf')
        self.as_of = attributes[:'asOf']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @pricing_component_id.nil?
        invalid_properties.push("invalid value for 'pricing_component_id', pricing_component_id cannot be nil.")
      end

      if @subscription_id.nil?
        invalid_properties.push("invalid value for 'subscription_id', subscription_id cannot be nil.")
      end

      if @invoice_id.nil?
        invalid_properties.push("invalid value for 'invoice_id', invoice_id cannot be nil.")
      end

      if @organization_id.nil?
        invalid_properties.push("invalid value for 'organization_id', organization_id cannot be nil.")
      end

      if @new_value.nil?
        invalid_properties.push("invalid value for 'new_value', new_value cannot be nil.")
      end

      if @old_value.nil?
        invalid_properties.push("invalid value for 'old_value', old_value cannot be nil.")
      end

      if @mode.nil?
        invalid_properties.push("invalid value for 'mode', mode cannot be nil.")
      end

      if @state.nil?
        invalid_properties.push("invalid value for 'state', state cannot be nil.")
      end

      if @as_of.nil?
        invalid_properties.push("invalid value for 'as_of', as_of cannot be nil.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @pricing_component_id.nil?
      return false if @subscription_id.nil?
      return false if @invoice_id.nil?
      return false if @organization_id.nil?
      return false if @new_value.nil?
      return false if @old_value.nil?
      return false if @mode.nil?
      mode_validator = EnumAttributeValidator.new('String', ["immediate", "delayed"])
      return false unless mode_validator.valid?(@mode)
      return false if @state.nil?
      state_validator = EnumAttributeValidator.new('String', ["New", "Accepted", "Rejected", "ChargeCreated"])
      return false unless state_validator.valid?(@state)
      return false if @as_of.nil?
      return true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] mode Object to be assigned
    def mode=(mode)
      validator = EnumAttributeValidator.new('String', ["immediate", "delayed"])
      unless validator.valid?(mode)
        fail ArgumentError, "invalid value for 'mode', must be one of #{validator.allowable_values}."
      end
      @mode = mode
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] state Object to be assigned
    def state=(state)
      validator = EnumAttributeValidator.new('String', ["New", "Accepted", "Rejected", "ChargeCreated"])
      unless validator.valid?(state)
        fail ArgumentError, "invalid value for 'state', must be one of #{validator.allowable_values}."
      end
      @state = state
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          applied == o.applied &&
          created == o.created &&
          changed_by == o.changed_by &&
          id == o.id &&
          pricing_component_id == o.pricing_component_id &&
          unit_of_measure_id == o.unit_of_measure_id &&
          subscription_id == o.subscription_id &&
          invoice_id == o.invoice_id &&
          organization_id == o.organization_id &&
          new_value == o.new_value &&
          old_value == o.old_value &&
          mode == o.mode &&
          state == o.state &&
          as_of == o.as_of
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [applied, created, changed_by, id, pricing_component_id, unit_of_measure_id, subscription_id, invoice_id, organization_id, new_value, old_value, mode, state, as_of].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Bfwd.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
