=begin
#BillForward REST API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3-SNAPSHOT

=end

require 'date'

module Bfwd
  # An invoice-payment specifies the amount of a particular payment used to pay part or entirety of the outstanding balance of the associated invoice.
  class InvoicePayment
    # {\"description\":\"The date when the associated payment was received.\",\"verbs\":[\"POST\",\"PUT\",\"GET\"]}
    attr_accessor :payment_received

    # {\"description\":\"The date when the associated payment was refunded.\",\"verbs\":[\"POST\",\"PUT\",\"GET\"]}
    attr_accessor :refund_received

    # { \"description\" : \"The UTC DateTime when the object was created.\", \"verbs\":[] }
    attr_accessor :created

    # { \"description\" : \"ID of the user who last updated the entity.\", \"verbs\":[] }
    attr_accessor :changed_by

    # { \"description\" : \"The UTC DateTime when the object was last updated.\", \"verbs\":[] }
    attr_accessor :updated

    # { \"description\" : \"ID of the payment-line.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :id

    # { \"description\" : \"CRM ID of the invoice.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :crm_id

    # { \"description\" : \"ID of the payment used.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :payment_id

    # { \"description\" : \"ID of the invoice associated with the payment-line.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :invoice_id

    # { \"description\" : \"ID of the organization associated with the invoice-payment.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :organization_id

    # { \"description\" : \"The currency of the payment specified by a three character ISO 4217 currency code.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :currency

    # Payment gateway associated with the payment
    attr_accessor :gateway

    # { \"description\" : \"The value that this payment-line represents.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :nominal_amount

    # { \"description\" : \"The value of the payment used by payment-line.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :actual_amount

    # { \"description\" : \"The refunded amount of the invoice-payment.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :refunded_amount

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'payment_received' => :'paymentReceived',
        :'refund_received' => :'refundReceived',
        :'created' => :'created',
        :'changed_by' => :'changedBy',
        :'updated' => :'updated',
        :'id' => :'id',
        :'crm_id' => :'crmID',
        :'payment_id' => :'paymentID',
        :'invoice_id' => :'invoiceID',
        :'organization_id' => :'organizationID',
        :'currency' => :'currency',
        :'gateway' => :'gateway',
        :'nominal_amount' => :'nominalAmount',
        :'actual_amount' => :'actualAmount',
        :'refunded_amount' => :'refundedAmount'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'payment_received' => :'DateTime',
        :'refund_received' => :'DateTime',
        :'created' => :'DateTime',
        :'changed_by' => :'String',
        :'updated' => :'DateTime',
        :'id' => :'String',
        :'crm_id' => :'String',
        :'payment_id' => :'String',
        :'invoice_id' => :'String',
        :'organization_id' => :'String',
        :'currency' => :'String',
        :'gateway' => :'String',
        :'nominal_amount' => :'Float',
        :'actual_amount' => :'Float',
        :'refunded_amount' => :'Float'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'paymentReceived')
        self.payment_received = attributes[:'paymentReceived']
      end

      if attributes.has_key?(:'refundReceived')
        self.refund_received = attributes[:'refundReceived']
      end

      if attributes.has_key?(:'created')
        self.created = attributes[:'created']
      end

      if attributes.has_key?(:'changedBy')
        self.changed_by = attributes[:'changedBy']
      end

      if attributes.has_key?(:'updated')
        self.updated = attributes[:'updated']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'crmID')
        self.crm_id = attributes[:'crmID']
      end

      if attributes.has_key?(:'paymentID')
        self.payment_id = attributes[:'paymentID']
      end

      if attributes.has_key?(:'invoiceID')
        self.invoice_id = attributes[:'invoiceID']
      end

      if attributes.has_key?(:'organizationID')
        self.organization_id = attributes[:'organizationID']
      end

      if attributes.has_key?(:'currency')
        self.currency = attributes[:'currency']
      end

      if attributes.has_key?(:'gateway')
        self.gateway = attributes[:'gateway']
      end

      if attributes.has_key?(:'nominalAmount')
        self.nominal_amount = attributes[:'nominalAmount']
      end

      if attributes.has_key?(:'actualAmount')
        self.actual_amount = attributes[:'actualAmount']
      end

      if attributes.has_key?(:'refundedAmount')
        self.refunded_amount = attributes[:'refundedAmount']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @payment_received.nil?
        invalid_properties.push("invalid value for 'payment_received', payment_received cannot be nil.")
      end

      if @refund_received.nil?
        invalid_properties.push("invalid value for 'refund_received', refund_received cannot be nil.")
      end

      if @crm_id.nil?
        invalid_properties.push("invalid value for 'crm_id', crm_id cannot be nil.")
      end

      if @payment_id.nil?
        invalid_properties.push("invalid value for 'payment_id', payment_id cannot be nil.")
      end

      if @invoice_id.nil?
        invalid_properties.push("invalid value for 'invoice_id', invoice_id cannot be nil.")
      end

      if @organization_id.nil?
        invalid_properties.push("invalid value for 'organization_id', organization_id cannot be nil.")
      end

      if @currency.nil?
        invalid_properties.push("invalid value for 'currency', currency cannot be nil.")
      end

      if @gateway.nil?
        invalid_properties.push("invalid value for 'gateway', gateway cannot be nil.")
      end

      if @nominal_amount.nil?
        invalid_properties.push("invalid value for 'nominal_amount', nominal_amount cannot be nil.")
      end

      if @actual_amount.nil?
        invalid_properties.push("invalid value for 'actual_amount', actual_amount cannot be nil.")
      end

      if @refunded_amount.nil?
        invalid_properties.push("invalid value for 'refunded_amount', refunded_amount cannot be nil.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @payment_received.nil?
      return false if @refund_received.nil?
      return false if @crm_id.nil?
      return false if @payment_id.nil?
      return false if @invoice_id.nil?
      return false if @organization_id.nil?
      return false if @currency.nil?
      return false if @gateway.nil?
      gateway_validator = EnumAttributeValidator.new('String', ["cybersource_token", "card_vault", "paypal_simple", "locustworld", "free", "coupon", "credit_note", "stripe", "braintree", "balanced", "paypal", "billforward_test", "offline", "trial", "stripeACH", "authorizeNet", "spreedly", "sagePay", "trustCommerce", "payvision", "kash"])
      return false unless gateway_validator.valid?(@gateway)
      return false if @nominal_amount.nil?
      return false if @actual_amount.nil?
      return false if @refunded_amount.nil?
      return true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] gateway Object to be assigned
    def gateway=(gateway)
      validator = EnumAttributeValidator.new('String', ["cybersource_token", "card_vault", "paypal_simple", "locustworld", "free", "coupon", "credit_note", "stripe", "braintree", "balanced", "paypal", "billforward_test", "offline", "trial", "stripeACH", "authorizeNet", "spreedly", "sagePay", "trustCommerce", "payvision", "kash"])
      unless validator.valid?(gateway)
        fail ArgumentError, "invalid value for 'gateway', must be one of #{validator.allowable_values}."
      end
      @gateway = gateway
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          payment_received == o.payment_received &&
          refund_received == o.refund_received &&
          created == o.created &&
          changed_by == o.changed_by &&
          updated == o.updated &&
          id == o.id &&
          crm_id == o.crm_id &&
          payment_id == o.payment_id &&
          invoice_id == o.invoice_id &&
          organization_id == o.organization_id &&
          currency == o.currency &&
          gateway == o.gateway &&
          nominal_amount == o.nominal_amount &&
          actual_amount == o.actual_amount &&
          refunded_amount == o.refunded_amount
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [payment_received, refund_received, created, changed_by, updated, id, crm_id, payment_id, invoice_id, organization_id, currency, gateway, nominal_amount, actual_amount, refunded_amount].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Bfwd.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
