=begin
#BillForward REST API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3-SNAPSHOT

=end

require 'date'

module Bfwd
  # PricingComponentTier
  class PricingComponentTier
    # { \"description\" : \"The lower threshold of the tier.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :lower_threshold

    # {  \"default\" : \"&infin;\",  \"description\" : \"The upper threshold of the tier. If this is left null the tier will be infinite\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :upper_threshold

    # { \"description\" : \"The UTC DateTime when the object was created.\", \"verbs\":[] }
    attr_accessor :created

    # { \"description\" : \"ID of the user who last updated the entity.\", \"verbs\":[] }
    attr_accessor :changed_by

    # { \"description\" : \"\", \"verbs\":[\"GET\"] }
    attr_accessor :id

    # { \"description\" : \"\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :crm_id

    # { \"description\" : \"Version ID of the associated pricing-component\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :pricing_component_version_id

    # { \"description\" : \"ID of the pricing-component associated with the pricing-component-tier.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :pricing_component_id

    # { \"description\" : \"ID of the product-rate-plan associated with the pricing-component-tier.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :product_rate_plan_id

    # { \"description\" : \"Organization associated with the pricing-component-tier.\", \"verbs\":[] }
    attr_accessor :organization_id

    # { \"description\" : \"Pricing calculation used to price items in this pricing tier. Unit pricing means every distinct value is used in the calculation. Fixed means that the total price of the tier is fixed regardless of the purchased amount.\", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :pricing_type

    # { \"description\" : \"Cost associated with tier. When the pricingType is fixed this is the total value. When pricingType is unit, this is the cost of each unit. \", \"verbs\":[\"POST\",\"PUT\",\"GET\"] }
    attr_accessor :price

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'lower_threshold' => :'lowerThreshold',
        :'upper_threshold' => :'upperThreshold',
        :'created' => :'created',
        :'changed_by' => :'changedBy',
        :'id' => :'id',
        :'crm_id' => :'crmID',
        :'pricing_component_version_id' => :'pricingComponentVersionID',
        :'pricing_component_id' => :'pricingComponentID',
        :'product_rate_plan_id' => :'productRatePlanID',
        :'organization_id' => :'organizationID',
        :'pricing_type' => :'pricingType',
        :'price' => :'price'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'lower_threshold' => :'Integer',
        :'upper_threshold' => :'Integer',
        :'created' => :'DateTime',
        :'changed_by' => :'String',
        :'id' => :'String',
        :'crm_id' => :'String',
        :'pricing_component_version_id' => :'String',
        :'pricing_component_id' => :'String',
        :'product_rate_plan_id' => :'String',
        :'organization_id' => :'String',
        :'pricing_type' => :'String',
        :'price' => :'Float'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'lowerThreshold')
        self.lower_threshold = attributes[:'lowerThreshold']
      end

      if attributes.has_key?(:'upperThreshold')
        self.upper_threshold = attributes[:'upperThreshold']
      end

      if attributes.has_key?(:'created')
        self.created = attributes[:'created']
      end

      if attributes.has_key?(:'changedBy')
        self.changed_by = attributes[:'changedBy']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'crmID')
        self.crm_id = attributes[:'crmID']
      end

      if attributes.has_key?(:'pricingComponentVersionID')
        self.pricing_component_version_id = attributes[:'pricingComponentVersionID']
      end

      if attributes.has_key?(:'pricingComponentID')
        self.pricing_component_id = attributes[:'pricingComponentID']
      end

      if attributes.has_key?(:'productRatePlanID')
        self.product_rate_plan_id = attributes[:'productRatePlanID']
      end

      if attributes.has_key?(:'organizationID')
        self.organization_id = attributes[:'organizationID']
      end

      if attributes.has_key?(:'pricingType')
        self.pricing_type = attributes[:'pricingType']
      end

      if attributes.has_key?(:'price')
        self.price = attributes[:'price']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @pricing_component_version_id.nil?
        invalid_properties.push("invalid value for 'pricing_component_version_id', pricing_component_version_id cannot be nil.")
      end

      if @pricing_type.nil?
        invalid_properties.push("invalid value for 'pricing_type', pricing_type cannot be nil.")
      end

      if @price.nil?
        invalid_properties.push("invalid value for 'price', price cannot be nil.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @pricing_component_version_id.nil?
      return false if @pricing_type.nil?
      pricing_type_validator = EnumAttributeValidator.new('String', ["unit", "fixed"])
      return false unless pricing_type_validator.valid?(@pricing_type)
      return false if @price.nil?
      return true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] pricing_type Object to be assigned
    def pricing_type=(pricing_type)
      validator = EnumAttributeValidator.new('String', ["unit", "fixed"])
      unless validator.valid?(pricing_type)
        fail ArgumentError, "invalid value for 'pricing_type', must be one of #{validator.allowable_values}."
      end
      @pricing_type = pricing_type
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          lower_threshold == o.lower_threshold &&
          upper_threshold == o.upper_threshold &&
          created == o.created &&
          changed_by == o.changed_by &&
          id == o.id &&
          crm_id == o.crm_id &&
          pricing_component_version_id == o.pricing_component_version_id &&
          pricing_component_id == o.pricing_component_id &&
          product_rate_plan_id == o.product_rate_plan_id &&
          organization_id == o.organization_id &&
          pricing_type == o.pricing_type &&
          price == o.price
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [lower_threshold, upper_threshold, created, changed_by, id, crm_id, pricing_component_version_id, pricing_component_id, product_rate_plan_id, organization_id, pricing_type, price].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Bfwd.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
