=begin
#BillForward REST API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3-SNAPSHOT

=end

require 'date'

module Bfwd
  # Request object for recalculating an invoice.
  class PricingComponentValueRequest
    # { \"description\" : \"The UTC DateTime when the object was created.\", \"verbs\":[] }
    attr_accessor :created

    # {\"default\":\"<span class=\\\"label label-default\\\"></span>\",\"description\":\"Modifies the current value used to calculate the recurring costs of the subscription. This can effectively be thought of as an upsert.Note: altering costs on invoices are made be editing charges.<br><span class=\\\"label label-default\\\">Setup Pricing</span> &mdash; Value changed if initial invoice has not been issued.<br><span class=\\\"label label-default\\\">In-Advance/Subscription Pricing</span> &mdash; Value changed and a charge added. If the change is delayed the current value on the subscription will show the delayed change.<br><span class=\\\"label label-default\\\">Arrears Pricing</span> &mdash; Value updated, and a pro-rated charge added to the subscription if required.<br><span class=\\\"label label-default\\\">Usage Pricing</span> &mdash; Usage created or updated for the current billing cycle.which is generated naturally &mdash; i.e. the invoice raised at the current period's end.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :value

    # {\"default\":\"<span class=\\\"label label-default\\\">as on pricing component</span>\",\"description\":\"Default behaviour when a value is changed by default the change mode from the pricing component is used.<br><span class=\\\"label label-default\\\">immediate</span> &mdash; Change will apply at the time the request is made.<br><span class=\\\"label label-default\\\">delayed</span> &mdash; Change will apply at the end of the current billing cycle.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :change_mode

    # {\"default\":\"<span class=\\\"label label-default\\\">Aggregated</span>\",\"description\":\"If the change results in a charge should it be invoiced straight away or on the next invoice.<br><span class=\\\"label label-default\\\">Immediate</span> &mdash; If the change has a cost associated with it , for example a pro-rated upgrade charge, an invoice will be raised at the time the request is made. If the invoice fails to be paid the upgrade will fail and the invoice will be voided. No credit or refund is issued for immediate downgrades.<br><span class=\\\"label label-default\\\">Aggregated</span> &mdash; If the change has a cost associated with it , for example a pro-rated upgrade charge, the charge will be added to the next invoice raised for this subscription. As no payment is required when the change is request the change always succeeds.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :invoicing_type

    # {\"default\":\"<span class=\\\"label label-default\\\">false</span>\",\"description\":\"If specified the change will have no cost associated with it. This is useful for immediately changing a value without creating any upgrade charge.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :no_charge

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'created' => :'created',
        :'value' => :'value',
        :'change_mode' => :'changeMode',
        :'invoicing_type' => :'invoicingType',
        :'no_charge' => :'noCharge'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'created' => :'DateTime',
        :'value' => :'Integer',
        :'change_mode' => :'String',
        :'invoicing_type' => :'String',
        :'no_charge' => :'BOOLEAN'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'created')
        self.created = attributes[:'created']
      end

      if attributes.has_key?(:'value')
        self.value = attributes[:'value']
      end

      if attributes.has_key?(:'changeMode')
        self.change_mode = attributes[:'changeMode']
      end

      if attributes.has_key?(:'invoicingType')
        self.invoicing_type = attributes[:'invoicingType']
      end

      if attributes.has_key?(:'noCharge')
        self.no_charge = attributes[:'noCharge']
      else
        self.no_charge = false
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @value.nil?
        invalid_properties.push("invalid value for 'value', value cannot be nil.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @value.nil?
      change_mode_validator = EnumAttributeValidator.new('String', ["immediate", "delayed"])
      return false unless change_mode_validator.valid?(@change_mode)
      invoicing_type_validator = EnumAttributeValidator.new('String', ["Immediate", "Aggregated"])
      return false unless invoicing_type_validator.valid?(@invoicing_type)
      return true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] change_mode Object to be assigned
    def change_mode=(change_mode)
      validator = EnumAttributeValidator.new('String', ["immediate", "delayed"])
      unless validator.valid?(change_mode)
        fail ArgumentError, "invalid value for 'change_mode', must be one of #{validator.allowable_values}."
      end
      @change_mode = change_mode
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] invoicing_type Object to be assigned
    def invoicing_type=(invoicing_type)
      validator = EnumAttributeValidator.new('String', ["Immediate", "Aggregated"])
      unless validator.valid?(invoicing_type)
        fail ArgumentError, "invalid value for 'invoicing_type', must be one of #{validator.allowable_values}."
      end
      @invoicing_type = invoicing_type
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          created == o.created &&
          value == o.value &&
          change_mode == o.change_mode &&
          invoicing_type == o.invoicing_type &&
          no_charge == o.no_charge
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [created, value, change_mode, invoicing_type, no_charge].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Bfwd.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
