=begin
#BillForward REST API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3-SNAPSHOT

=end

require 'date'

module Bfwd
  # Entity for requesting a price quote.
  class QuoteRequest
    # { \"description\" : \"The UTC DateTime when the object was created.\", \"verbs\":[] }
    attr_accessor :created

    # { \"description\" : \"ID of the user who last updated the entity.\", \"verbs\":[] }
    attr_accessor :changed_by

    # {\"description\":\"The product for which a price quote is requested.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :product

    # {\"description\":\"The rate plan (of some product) for which a price quote is requested.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :product_rate_plan

    # {\"description\":\"ID of the account for which a price quote is requested.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :account_id

    # {\"description\":\"ID of the subscription for which a price quote is requested.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :subscription_id

    # {\"description\":\"version ID of the subscription for which a price quote is requested.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :subscription_version_id

    # {\"default\":\"RecurringPeriod\",\"description\":\"Subscription scenario with which the quote is concerned.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :quote_for

    # {\"default\":true,\"description\":\"Whether or not to pro-rate the price (if the quote concerns a time interval containing a partial period).\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :prorated

    # {\"default\":false,\"description\":\"Whether or not to present a waived final price in the quote.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :free

    # {\"default\":true,\"description\":\"Whether or not to include coupons which have already been applied to the subscription.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :include_applied_coupons

    # {\"default\":\"(Now)\",\"description\":\"The time-beginning of the interval with which the quote is concerned. This can be used to request a quote across partial or multiple periods &mdash; potentially pro-rating its price.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :period_start

    # {\"default\":\"(End of current period)\",\"description\":\"The time-ending of the interval with which the quote is concerned. This can be used to request a quote across partial or multiple periods &mdash; potentially pro-rating its price.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :period_end

    # {\"default\":\"<span class=\\\"label label-default\\\">Rollover</span>\",\"description\":\"Defines the behaviour applied to any outstanding credit resulting from the application of the charge..<br><span class=\\\"label label-default\\\">Rollover</span> &mdash; Outstanding credit is returned to the accounts credit pool.<br><span class=\\\"label label-default\\\">Discard</span> &mdash; Outstanding credit is lost.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :remaining_credit_behaviour

    # {\"description\":\"A list of pricing components (and their values) to consider in calculating the quote.\",\"verbs\":[\"POST\"]}
    attr_accessor :quantities

    # {\"description\":\"A list of coupon codes to consider in calculating the quote.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :coupon_codes

    # { \"description\" : \"Pricing behaviour defines how migration charges are calculated. <span class=\\\"label label-default\\\">DifferenceProRated</span> calculates the difference between in-advance charges of the existing and new rate-plan, then pro-rates based on time remaining. <span class=\\\"label label-default\\\">None</span> sets the migration charge as zero cost. <span class=\\\"label label-default\\\">Full</span> sets the costs as the total of the new rate-plans in-advance charges.  <span class=\\\"label label-default\\\">Difference</span> is the same calculation as <span class=\\\"label label-default\\\">DifferenceProRated</span> but no pro-ration is applied.  <span class=\\\"label label-default\\\">ProRated</span> differs depending on two cases; when moving to a rate-plan of the same duration it pro-rates the in-advance charges of the new rate-plan. If the duration is different, a credit-note will be issued any remaining time on the existing plans billing period.\", \"default\" : \"DifferenceProRated\",  \"verbs\":[\"POST\",\"GET\"] }
    attr_accessor :pricing_behaviour

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'created' => :'created',
        :'changed_by' => :'changedBy',
        :'product' => :'product',
        :'product_rate_plan' => :'productRatePlan',
        :'account_id' => :'accountID',
        :'subscription_id' => :'subscriptionID',
        :'subscription_version_id' => :'subscriptionVersionID',
        :'quote_for' => :'quoteFor',
        :'prorated' => :'prorated',
        :'free' => :'free',
        :'include_applied_coupons' => :'includeAppliedCoupons',
        :'period_start' => :'periodStart',
        :'period_end' => :'periodEnd',
        :'remaining_credit_behaviour' => :'remainingCreditBehaviour',
        :'quantities' => :'quantities',
        :'coupon_codes' => :'couponCodes',
        :'pricing_behaviour' => :'pricingBehaviour'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'created' => :'DateTime',
        :'changed_by' => :'String',
        :'product' => :'String',
        :'product_rate_plan' => :'String',
        :'account_id' => :'String',
        :'subscription_id' => :'String',
        :'subscription_version_id' => :'String',
        :'quote_for' => :'String',
        :'prorated' => :'BOOLEAN',
        :'free' => :'BOOLEAN',
        :'include_applied_coupons' => :'BOOLEAN',
        :'period_start' => :'DateTime',
        :'period_end' => :'DateTime',
        :'remaining_credit_behaviour' => :'String',
        :'quantities' => :'Array<QuoteRequestValue>',
        :'coupon_codes' => :'Array<String>',
        :'pricing_behaviour' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'created')
        self.created = attributes[:'created']
      end

      if attributes.has_key?(:'changedBy')
        self.changed_by = attributes[:'changedBy']
      end

      if attributes.has_key?(:'product')
        self.product = attributes[:'product']
      end

      if attributes.has_key?(:'productRatePlan')
        self.product_rate_plan = attributes[:'productRatePlan']
      end

      if attributes.has_key?(:'accountID')
        self.account_id = attributes[:'accountID']
      end

      if attributes.has_key?(:'subscriptionID')
        self.subscription_id = attributes[:'subscriptionID']
      end

      if attributes.has_key?(:'subscriptionVersionID')
        self.subscription_version_id = attributes[:'subscriptionVersionID']
      end

      if attributes.has_key?(:'quoteFor')
        self.quote_for = attributes[:'quoteFor']
      end

      if attributes.has_key?(:'prorated')
        self.prorated = attributes[:'prorated']
      else
        self.prorated = false
      end

      if attributes.has_key?(:'free')
        self.free = attributes[:'free']
      else
        self.free = false
      end

      if attributes.has_key?(:'includeAppliedCoupons')
        self.include_applied_coupons = attributes[:'includeAppliedCoupons']
      else
        self.include_applied_coupons = false
      end

      if attributes.has_key?(:'periodStart')
        self.period_start = attributes[:'periodStart']
      end

      if attributes.has_key?(:'periodEnd')
        self.period_end = attributes[:'periodEnd']
      end

      if attributes.has_key?(:'remainingCreditBehaviour')
        self.remaining_credit_behaviour = attributes[:'remainingCreditBehaviour']
      end

      if attributes.has_key?(:'quantities')
        if (value = attributes[:'quantities']).is_a?(Array)
          self.quantities = value
        end
      end

      if attributes.has_key?(:'couponCodes')
        if (value = attributes[:'couponCodes']).is_a?(Array)
          self.coupon_codes = value
        end
      end

      if attributes.has_key?(:'pricingBehaviour')
        self.pricing_behaviour = attributes[:'pricingBehaviour']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @product_rate_plan.nil?
        invalid_properties.push("invalid value for 'product_rate_plan', product_rate_plan cannot be nil.")
      end

      if @period_end.nil?
        invalid_properties.push("invalid value for 'period_end', period_end cannot be nil.")
      end

      if @remaining_credit_behaviour.nil?
        invalid_properties.push("invalid value for 'remaining_credit_behaviour', remaining_credit_behaviour cannot be nil.")
      end

      if @pricing_behaviour.nil?
        invalid_properties.push("invalid value for 'pricing_behaviour', pricing_behaviour cannot be nil.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @product_rate_plan.nil?
      quote_for_validator = EnumAttributeValidator.new('String', ["InitialPeriod", "RecurringPeriod", "Upgrade", "Migration"])
      return false unless quote_for_validator.valid?(@quote_for)
      return false if @period_end.nil?
      return false if @remaining_credit_behaviour.nil?
      remaining_credit_behaviour_validator = EnumAttributeValidator.new('String', ["Rollover", "Discard"])
      return false unless remaining_credit_behaviour_validator.valid?(@remaining_credit_behaviour)
      return false if @pricing_behaviour.nil?
      pricing_behaviour_validator = EnumAttributeValidator.new('String', ["None", "Full", "Difference", "DifferenceProRated", "ProRated"])
      return false unless pricing_behaviour_validator.valid?(@pricing_behaviour)
      return true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] quote_for Object to be assigned
    def quote_for=(quote_for)
      validator = EnumAttributeValidator.new('String', ["InitialPeriod", "RecurringPeriod", "Upgrade", "Migration"])
      unless validator.valid?(quote_for)
        fail ArgumentError, "invalid value for 'quote_for', must be one of #{validator.allowable_values}."
      end
      @quote_for = quote_for
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] remaining_credit_behaviour Object to be assigned
    def remaining_credit_behaviour=(remaining_credit_behaviour)
      validator = EnumAttributeValidator.new('String', ["Rollover", "Discard"])
      unless validator.valid?(remaining_credit_behaviour)
        fail ArgumentError, "invalid value for 'remaining_credit_behaviour', must be one of #{validator.allowable_values}."
      end
      @remaining_credit_behaviour = remaining_credit_behaviour
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] pricing_behaviour Object to be assigned
    def pricing_behaviour=(pricing_behaviour)
      validator = EnumAttributeValidator.new('String', ["None", "Full", "Difference", "DifferenceProRated", "ProRated"])
      unless validator.valid?(pricing_behaviour)
        fail ArgumentError, "invalid value for 'pricing_behaviour', must be one of #{validator.allowable_values}."
      end
      @pricing_behaviour = pricing_behaviour
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          created == o.created &&
          changed_by == o.changed_by &&
          product == o.product &&
          product_rate_plan == o.product_rate_plan &&
          account_id == o.account_id &&
          subscription_id == o.subscription_id &&
          subscription_version_id == o.subscription_version_id &&
          quote_for == o.quote_for &&
          prorated == o.prorated &&
          free == o.free &&
          include_applied_coupons == o.include_applied_coupons &&
          period_start == o.period_start &&
          period_end == o.period_end &&
          remaining_credit_behaviour == o.remaining_credit_behaviour &&
          quantities == o.quantities &&
          coupon_codes == o.coupon_codes &&
          pricing_behaviour == o.pricing_behaviour
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [created, changed_by, product, product_rate_plan, account_id, subscription_id, subscription_version_id, quote_for, prorated, free, include_applied_coupons, period_start, period_end, remaining_credit_behaviour, quantities, coupon_codes, pricing_behaviour].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Bfwd.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
