=begin
#BillForward REST API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3-SNAPSHOT

=end

require 'date'

module Bfwd
  # Request object for advancing a subscription's flow through time.
  class TimeRequest
    # { \"description\" : \"The UTC DateTime when the object was created.\", \"verbs\":[] }
    attr_accessor :created

    # {\"description\":\"(Required: one of [`periods`, `to`])<br>The number of period boundaries up to which the subscription should advance. A 1-value advances the subscription to the end of its current service period. Higher values advance the subscription to subsequent period boundaries.\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :periods

    # {\"description\":\"(Required: one of [`periods`, `to`])<br>The time up until which the subscription should be fast-forwarded.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :to

    # {\"default\":false,\"description\":\"Changes described in the response:<br><span class=\\\"label label-default\\\">true</span> &mdash; Are not actually performed; your subscription remains unchanged, no billing events run, and no invoices are executed.<br><span class=\\\"label label-default\\\">false</span> &mdash; Are actually performed and committed.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :dry_run

    # {\"default\":false,\"description\":\"As time scrubs forward:<br><span class=\\\"label label-default\\\">true</span> &mdash; Raise no invoice upon advancing over a period boundary.<br><span class=\\\"label label-default\\\">false</span> &mdash; Raise invoices for any period that is entered.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :skip_intermediate_periods

    # {\"default\":true,\"description\":\"As time scrubs forward:<br><span class=\\\"label label-default\\\">true</span> &mdash; Run any amendments that were scheduled to action.<br><span class=\\\"label label-default\\\">false</span> &mdash; Do not run any amendments that were scheduled to action.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :handle_amendments

    # {\"default\":\"<span class=\\\"label label-default\\\">SingleAttempt</span>\",\"description\":\"What strategy to use when executing any invoices raised as time advances:<br><span class=\\\"label label-default\\\">SingleAttempt</span> &mdash; Execute any invoice just once.<br><span class=\\\"label label-default\\\">FollowDunning</span> &mdash; Apply the existing dunning strategy when executing invoices.<br><span class=\\\"label label-default\\\">None</span>: Do not execute invoices.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :execution_strategy

    # {\"default\":false,\"description\":\"Once the subscription is advanced through time:<br><span class=\\\"label label-default\\\">true</span> &mdash; Freeze the subscription.<br><span class=\\\"label label-default\\\">false</span> &mdash; Do not freeze the subscription.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :freeze_on_completion

    # {\"default\":true,\"description\":\"When advancing onto an instant in time:<br><span class=\\\"label label-default\\\">true</span> &mdash; Action the events scheduled for your destination time. Amendments scheduled at your destined time will be actioned during this time travel. Advancing to a period boundary will promote your subscription to the period on the future side of that boundary.<br><span class=\\\"label label-default\\\">false</span> &mdash; Do not action events scheduled for your destination time. Amendments scheduled at your destined time will not be actioned during this time travel. Advancing to a period boundary will result in your subscription's remaining within the period on the past side of that boundary.\",\"verbs\":[\"POST\",\"GET\"]}
    attr_accessor :advance_inclusively

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'created' => :'created',
        :'periods' => :'periods',
        :'to' => :'to',
        :'dry_run' => :'dryRun',
        :'skip_intermediate_periods' => :'skipIntermediatePeriods',
        :'handle_amendments' => :'handleAmendments',
        :'execution_strategy' => :'executionStrategy',
        :'freeze_on_completion' => :'freezeOnCompletion',
        :'advance_inclusively' => :'advanceInclusively'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'created' => :'DateTime',
        :'periods' => :'Integer',
        :'to' => :'DateTime',
        :'dry_run' => :'BOOLEAN',
        :'skip_intermediate_periods' => :'BOOLEAN',
        :'handle_amendments' => :'BOOLEAN',
        :'execution_strategy' => :'String',
        :'freeze_on_completion' => :'BOOLEAN',
        :'advance_inclusively' => :'BOOLEAN'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'created')
        self.created = attributes[:'created']
      end

      if attributes.has_key?(:'periods')
        self.periods = attributes[:'periods']
      end

      if attributes.has_key?(:'to')
        self.to = attributes[:'to']
      end

      if attributes.has_key?(:'dryRun')
        self.dry_run = attributes[:'dryRun']
      else
        self.dry_run = false
      end

      if attributes.has_key?(:'skipIntermediatePeriods')
        self.skip_intermediate_periods = attributes[:'skipIntermediatePeriods']
      else
        self.skip_intermediate_periods = false
      end

      if attributes.has_key?(:'handleAmendments')
        self.handle_amendments = attributes[:'handleAmendments']
      else
        self.handle_amendments = false
      end

      if attributes.has_key?(:'executionStrategy')
        self.execution_strategy = attributes[:'executionStrategy']
      end

      if attributes.has_key?(:'freezeOnCompletion')
        self.freeze_on_completion = attributes[:'freezeOnCompletion']
      else
        self.freeze_on_completion = false
      end

      if attributes.has_key?(:'advanceInclusively')
        self.advance_inclusively = attributes[:'advanceInclusively']
      else
        self.advance_inclusively = false
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      execution_strategy_validator = EnumAttributeValidator.new('String', ["SingleAttempt", "FollowDunning", "None"])
      return false unless execution_strategy_validator.valid?(@execution_strategy)
      return true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] execution_strategy Object to be assigned
    def execution_strategy=(execution_strategy)
      validator = EnumAttributeValidator.new('String', ["SingleAttempt", "FollowDunning", "None"])
      unless validator.valid?(execution_strategy)
        fail ArgumentError, "invalid value for 'execution_strategy', must be one of #{validator.allowable_values}."
      end
      @execution_strategy = execution_strategy
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          created == o.created &&
          periods == o.periods &&
          to == o.to &&
          dry_run == o.dry_run &&
          skip_intermediate_periods == o.skip_intermediate_periods &&
          handle_amendments == o.handle_amendments &&
          execution_strategy == o.execution_strategy &&
          freeze_on_completion == o.freeze_on_completion &&
          advance_inclusively == o.advance_inclusively
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [created, periods, to, dry_run, skip_intermediate_periods, handle_amendments, execution_strategy, freeze_on_completion, advance_inclusively].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Bfwd.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
