=begin
#BillForward REST API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3-SNAPSHOT

=end

require 'date'

module Bfwd
  # UpdatePricingComponentValueChangeResult
  class UpdatePricingComponentValueChangeResult
    # The ID of the updated Pricing Component.
    attr_accessor :pricing_component_id

    # The name of the updated Pricing Component.
    attr_accessor :pricing_component_name

    # The public name of the updated Pricing Component.
    attr_accessor :pricing_component_public_name

    # The value of the Pricing Component after the update.
    attr_accessor :new_value

    # The Pricing Component Value before the update.
    attr_accessor :old_value

    # The type of the result.
    attr_accessor :type

    # The ID of the updated Subscription.
    attr_accessor :subscription_id

    # The issued amount.
    attr_accessor :amount

    # This field state if the issued amount is a Debit or Credit. This field will be null if the amount is 0 (zero)
    attr_accessor :charge_type

    # If a debit or credit charge has been created in the process, this field will contain it.
    attr_accessor :charge

    # If an amendment has been created in the prcess (ie. if the update has to be delayed to the ending billing period), this field will contain it.
    attr_accessor :amendment

    # {\"description\":\"The state of the update. <ul><li>Succeeded: The change has been applied. This state only happens for immediate changes and if the generated invoice has been successfully paid.</li><li>Failed: The change has not been applied. This state only happens for immediate changes and if the generated invoice has not been successfully paid.</li><li>Pending: The changes has not been applied yet. An amendment has been created that will be triggered in the future applying the change. The resulting state can't be predicted at this time.</li></ul>\"}
    attr_accessor :state

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'pricing_component_id' => :'pricingComponentID',
        :'pricing_component_name' => :'pricingComponentName',
        :'pricing_component_public_name' => :'pricingComponentPublicName',
        :'new_value' => :'newValue',
        :'old_value' => :'oldValue',
        :'type' => :'type',
        :'subscription_id' => :'subscriptionID',
        :'amount' => :'amount',
        :'charge_type' => :'chargeType',
        :'charge' => :'charge',
        :'amendment' => :'amendment',
        :'state' => :'state'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'pricing_component_id' => :'String',
        :'pricing_component_name' => :'String',
        :'pricing_component_public_name' => :'String',
        :'new_value' => :'Integer',
        :'old_value' => :'Integer',
        :'type' => :'String',
        :'subscription_id' => :'String',
        :'amount' => :'Float',
        :'charge_type' => :'String',
        :'charge' => :'SubscriptionCharge',
        :'amendment' => :'Amendment',
        :'state' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'pricingComponentID')
        self.pricing_component_id = attributes[:'pricingComponentID']
      end

      if attributes.has_key?(:'pricingComponentName')
        self.pricing_component_name = attributes[:'pricingComponentName']
      end

      if attributes.has_key?(:'pricingComponentPublicName')
        self.pricing_component_public_name = attributes[:'pricingComponentPublicName']
      end

      if attributes.has_key?(:'newValue')
        self.new_value = attributes[:'newValue']
      end

      if attributes.has_key?(:'oldValue')
        self.old_value = attributes[:'oldValue']
      end

      if attributes.has_key?(:'type')
        self.type = attributes[:'type']
      end

      if attributes.has_key?(:'subscriptionID')
        self.subscription_id = attributes[:'subscriptionID']
      end

      if attributes.has_key?(:'amount')
        self.amount = attributes[:'amount']
      end

      if attributes.has_key?(:'chargeType')
        self.charge_type = attributes[:'chargeType']
      end

      if attributes.has_key?(:'charge')
        self.charge = attributes[:'charge']
      end

      if attributes.has_key?(:'amendment')
        self.amendment = attributes[:'amendment']
      end

      if attributes.has_key?(:'state')
        self.state = attributes[:'state']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      type_validator = EnumAttributeValidator.new('String', ["Upgrade", "Downgrade", "NoChange"])
      return false unless type_validator.valid?(@type)
      charge_type_validator = EnumAttributeValidator.new('String', ["Credit", "Debit"])
      return false unless charge_type_validator.valid?(@charge_type)
      state_validator = EnumAttributeValidator.new('String', ["Failed", "Succeeded", "Pending"])
      return false unless state_validator.valid?(@state)
      return true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] type Object to be assigned
    def type=(type)
      validator = EnumAttributeValidator.new('String', ["Upgrade", "Downgrade", "NoChange"])
      unless validator.valid?(type)
        fail ArgumentError, "invalid value for 'type', must be one of #{validator.allowable_values}."
      end
      @type = type
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] charge_type Object to be assigned
    def charge_type=(charge_type)
      validator = EnumAttributeValidator.new('String', ["Credit", "Debit"])
      unless validator.valid?(charge_type)
        fail ArgumentError, "invalid value for 'charge_type', must be one of #{validator.allowable_values}."
      end
      @charge_type = charge_type
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] state Object to be assigned
    def state=(state)
      validator = EnumAttributeValidator.new('String', ["Failed", "Succeeded", "Pending"])
      unless validator.valid?(state)
        fail ArgumentError, "invalid value for 'state', must be one of #{validator.allowable_values}."
      end
      @state = state
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          pricing_component_id == o.pricing_component_id &&
          pricing_component_name == o.pricing_component_name &&
          pricing_component_public_name == o.pricing_component_public_name &&
          new_value == o.new_value &&
          old_value == o.old_value &&
          type == o.type &&
          subscription_id == o.subscription_id &&
          amount == o.amount &&
          charge_type == o.charge_type &&
          charge == o.charge &&
          amendment == o.amendment &&
          state == o.state
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [pricing_component_id, pricing_component_name, pricing_component_public_name, new_value, old_value, type, subscription_id, amount, charge_type, charge, amendment, state].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Bfwd.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
